function dump(o)
   if type(o) == 'table' then
      local s = '{ '
      for k,v in pairs(o) do
         if type(k) ~= 'number' then k = '"'..k..'"' end
         s = s .. '['..k..'] = ' .. dump(v) .. ','
      end
      return s .. '} '
   else
      return tostring(o)
   end
end

function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

local TalentTrees = {
	[1] = {308, 312, 316, 320,},
	[2] = {309, 313, 317, 321,},
	[3] = {307, 311, 315, 319,},
	[4] = {310, 314, 318, 324,},
}

c=""

local addon = LibStub("AceAddon-3.0"):NewAddon("TableData", "AceConsole-3.0")
local acegui = LibStub("AceGUI-3.0")
local tableDataObject = LibStub("LibDataBroker-1.1"):NewDataObject("TableData", {

type = "data source",
text = "Table Data",
icon = "Interface\\Icons\\Sanctum_features_missiontable",

OnClick = function() 
	--[[

	local missions = C_Garrison.GetAvailableMissions(123) 
	local usedMissions = C_Garrison.GetInProgressMissions(123)
	
	--renown
	renown = C_CovenantSanctumUI.GetRenownLevel() --added
	campaignProgress = C_CurrencyInfo.GetCurrencyInfo(1889).quantity
	]]--
	playerLevel = UnitLevel("player")--added
	
	--class
	local playerLoc = PlayerLocation:CreateFromUnit("player")
	playerClass = C_PlayerInfo.GetClass(playerLoc)--added
	playerName = C_PlayerInfo.GetName(playerLoc)--added
	currentCovenant = C_Covenants.GetActiveCovenantID() -- 0None 1K 2V 3NF 4NL
	--[[
	--sanctum upgrade 1
	--sanctum upgrade 2
	--sanctum upgrade 3 
	--sanctum upgrade 4
	sanctumUpgrades = {}
	for i=1, 4 do sanctumUpgrades[i] = 0 end
	
	for covrot = 1, 4 do
	for i = 1, #TalentTrees[covrot] do --Covenant Talents from HCTable
	
		local treeInfo = C_Garrison.GetTalentTreeInfo(TalentTrees[covrot][i])

		for j = 1, #treeInfo.talents do
			local T = treeInfo.talents[j]
			if T["researched"] and (T["tier"]+1 > sanctumUpgrades[i]) then
				sanctumUpgrades[i] = T["tier"]+1
			end
		end
	end
	end
	---117, 138
	--campaign progress for player
	campaignProgress = 0
	campaignMax = 0
	campaignChapters = C_CampaignInfo.GetChapterIDs(117)
	currentCampaignChapter = C_CampaignInfo.GetCurrentChapterID(117)

	i = 0
	for i, id in pairs(campaignChapters) do
		if id == currentCampaignChapter then
			campaignProgress = i - 1
			
		end
		campaignMax = i
	end
	if (currentCampaignChapter == nil) then
		campaignProgress = 9
	end
	c = dump(C_CampaignInfo.GetAvailableCampaigns())
	--korthia progress for player
	korthiaProgress = 0
	korthiaMax = 0
	korthiaChapters = C_CampaignInfo.GetChapterIDs(138)
	c = c .. dump(korthiaChapters)
	currentKorthiaChapter = C_CampaignInfo.GetCampaignChapterInfo(138)

	c=c..dump(currentKorthiaChapter)
	i = 0
	for i, id in pairs(korthiaChapters) do
		if id == currentKorthiaChapter then
			korthiaProgress = i - 1
			
		end
		korthiaMax = i
	end
	--followers obtained (individual)
	followerList = C_Garrison.GetFollowers(123)
	followerCount = tablelength(followerList)
	followerTable = {}

	for i, j in pairs(followerList) do
		followerTable[i] = j["name"]

	end
	--ilvl
	
	itemlevel, equippedItemlevel = GetAverageItemLevel()
	itemlevel = math.floor(itemlevel)
	--anima 1813
	anima = C_CurrencyInfo.GetCurrencyInfo(1813).quantity
	--souls
	souls = C_CurrencyInfo.GetCurrencyInfo(1810).quantity
	]]--
	
	local textStore
	

	local frame = acegui:Create("Frame")
	frame:SetTitle("Table Data")
	frame:SetStatusText("Table Data")
	frame:SetCallback("OnClose", function(widget) acegui:Release(widget) end)
	frame:SetLayout("Flow")
	frame:SetHeight(630)
	frame:SetWidth(430)

	local editbox = acegui:Create("MultiLineEditBox")
	editbox:SetNumLines(10)
	editbox:SetLabel("Copy this:")
	editbox:SetHeight(400)
	editbox:SetWidth(400)
	editbox:SetCallback("OnEnterPressed", function(widget, event, text) textStore = text end)
	frame:AddChild(editbox)

	editbox:SetText("https://forms.gle/yQ9ZJwjrJVjKe7jd9 - Please submit data at this link :D")
	editbox:HighlightText()
	editbox:SetFocus()
	--[[
	local buttonchar = acegui:Create("Button")
	buttonchar:SetText("Populate with available missions")
	buttonchar:SetWidth(400)
	buttonchar:SetCallback("OnClick", 
		function() 
			
			a = followerCount .. "," .. renown .. "," .. campaignProgress .. ","
			for key,value in pairs(missions) do
				a = a .. value["name"]:gsub(",", "~") .. ","
			end
			for key,value in pairs(usedMissions) do
				a = a .. value["name"]:gsub(",", "~") .. ","
			end
			
			editbox:SetText(a:sub(1, -2))
			editbox:HighlightText()
			editbox:SetFocus()
		end
	)
	
	
	local buttonchar2 = acegui:Create("Button")
	buttonchar2:SetText("Populate with covenant and table progression")
	buttonchar2:SetWidth(400)
	buttonchar2:SetCallback("OnClick", 
		function() 

			b = playerName .. "," .. playerClass .. "," .. playerLevel .. "," .. renown .. "," .. currentCovenant .. "," .. campaignProgress .. "," .. campaignMax .. "," .. korthiaProgress .. "," .. korthiaMax .. "," .. itemlevel .. "," .. anima .. "," .. souls .. "," .. sanctumUpgrades[1] .. "," .. sanctumUpgrades[2] .. "," .. sanctumUpgrades[3] .. "," .. sanctumUpgrades[4] .. ","
			for i,v in pairs(followerTable) do
				b = b .. v .. ","
			end
			editbox:SetText(b:sub(1, -2))
			editbox:HighlightText()
		end
	)
	frame:AddChild(buttonchar)
	frame:AddChild(buttonchar2)
	]]--
	local buttonchar3 = acegui:Create("Button")
	buttonchar3:SetText("Submission Link")
	buttonchar3:SetWidth(400)
	buttonchar3:SetCallback("OnClick", 
		function() 
			editbox:SetText("Not accepting any more. Sorry. 10.0 data collection soon™")
			editbox:HighlightText()
		end
	)
	frame:AddChild(buttonchar3)
	
	
	local buttonchar4 = acegui:Create("Button")
	buttonchar4:SetText("ALPHA - Dungeon and Raid Progress Dump")
	buttonchar4:SetWidth(400)
	buttonchar4:SetCallback("OnClick", 
		function() 
		
			local s = playerName .. "\n";-- .. playerClass .. "\n" .. playerLevel .. "\n" .. currentCovenant.. "\n";
			local DnRData = { AllTheThings.GetDataCache() }
			DnRData = DnRData[1]["g"][1]["g"]
			
			for k,v in pairs(DnRData) do
				--k exp id, v exp prog, tot, g
				s = s .. k .. "i" .. 0 .. "," .. v["progress"] .. "x" .. v["total"] .. "\n"
				for l, w in pairs(v["g"]) do
					if w["progress"] ~= nil then
						s = s .. k .. "i" .. l .. "," .. w["progress"] .. "x" .. w["total"] .. "\n"
					end
					--l inst id, w inst prog, tot (maybe)
				end
			end
			editbox:SetText(s)
			--editbox:SetText(dump2("[g]",vQCP_MainData, 5))
			editbox:HighlightText()
		end
	)
	frame:AddChild(buttonchar4)
end,
})
local icon2 = LibStub("LibDBIcon-1.0")




function addon:OnInitialize() 
self.db = LibStub("AceDB-3.0"):New("TableDataDB", { profile = { minimap = { hide = false, }, }, })
icon2:Register("TableData", tableDataObject, self.db.profile.minimap)
self:RegisterChatCommand("hidetabledata", "hideIcon")
end

function addon:hideIcon() 
	self.db.profile.minimap.hide = not self.db.profile.minimap.hide 
	if self.db.profile.minimap.hide 
		then icon2:Hide("TableData") 
		else icon2:Show("TableData") 
	end 
end